#!/usr/bin/env bash

# Terminate already running bar instances
# If all your bars have ipc enabled, you can use 
polybar-msg cmd quit
# Otherwise you can use the nuclear option:
killall -q polybar



echo "---" | tee -a /tmp/polybar1.log /tmp/polybar2.log

if [[ "$1" == "normal" ]] || [[ "$1" == "inverted" ]]; then
	polybar barvertical 2>&1 | tee -a /tmp/polybar2.log & disown
else
	polybar barhorizontal 2>&1 | tee -a /tmp/polybar1.log & disown
fi

echo "Bar launched..."
